- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::MultiVectorMatrix Class Reference

Class for Matrices with few columns that consists of Vectors. More...

`#include <IpMultiVectorMatrix.hpp>`

Inheritance diagram for Ipopt::MultiVectorMatrix:

[legend]
Collaboration diagram for Ipopt::MultiVectorMatrix:

[legend]
List of all members.

## Public Member Functions
SmartPtr< MultiVectorMatrix > | MakeNewMultiVectorMatrix () const
| Create a new MultiVectorMatrix from same MatrixSpace.
SmartPtr< const Vector > | GetVector (Index i) const
| Get a Vector in a particular column as a const Vector.
SmartPtr< Vector > | GetVectorNonConst (Index i)
| Get a Vector in a particular column as a non-const Vector.
void | ScaleRows (const Vector &scal_vec)
| Method for scaling the rows of the matrix, using the ElementWiseMultiply method for each column vector.
void | ScaleColumns (const Vector &scal_vec)
| Method for scaling the columns of the matrix, using the Scal method for each column vector.
void | AddOneMultiVectorMatrix (Number a, const MultiVectorMatrix &mv1, Number c)
| Adding another MultiVectorMatrix, using the AddOneVector methods for the individual column vectors.
void | AddRightMultMatrix (Number a, const MultiVectorMatrix &U, const Matrix &C, Number b)
| Multiplying a Matrix C (for now assumed to be a DenseGenMatrix) from the right to a MultiVectorMatrix U and adding the result to this MultiVectorMatrix V.
void | FillWithNewVectors ()
| Method for initializing all Vectors with new (uninitialized) Vectors.
void | LRMultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Method for adding the low-rank update matrix corresponding to this matrix to a vector.
SmartPtr< const VectorSpace > | ColVectorSpace () const
| Vector space for the columns.
SmartPtr< const MultiVectorMatrixSpace > | MultiVectorMatrixOwnerSpace () const
| Return the MultiVectorMatrixSpace.
Constructors / Destructors
| MultiVectorMatrix (const MultiVectorMatrixSpace *owner_space)
| Constructor, taking the owner_space.
| ~MultiVectorMatrix ()
| Destructor.
void | SetVector (Index i, const Vector &vec)
| Set a particular Vector at a given column position, replacing another vector if there has been one.
void | SetVectorNonConst (Index i, Vector &vec)
| Set a particular Vector at a given column position, replacing another vector if there has been one.
## Protected Member Functions
Overloaded methods from Matrix base class
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply.
virtual void | TransMultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply.
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan).
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix.
virtual void | ComputeColAMaxImpl (Vector &cols_norms, bool init) const
| Compute the max-norm of the columns in the matrix.
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| MultiVectorMatrix ()
| Default Constructor.
| MultiVectorMatrix (const MultiVectorMatrix &)
| Copy Constructor.
void | operator= (const MultiVectorMatrix &)
| Overloaded Equals Operator.
const Vector * | ConstVec (Index i) const
| Method for accessing the internal Vectors internally.
Vector * | Vec (Index i)
| Method for accessing the internal Vectors internally.
## Private Attributes
const MultiVectorMatrixSpace * | owner_space_
std::vector< SmartPtr< const Vector > > | const_vecs_
| space for storing the const Vector's
std::vector< SmartPtr< Vector > > | non_const_vecs_
| space for storing the non-const Vector's

## Detailed Description

Class for Matrices with few columns that consists of Vectors.

Those matrices are for example useful in the implementation of limited memory quasi-Newton methods.

Definition at line 25 of file IpMultiVectorMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::MultiVectorMatrix::MultiVectorMatrix | ( | const MultiVectorMatrixSpace * | owner_space | ) |

Constructor, taking the owner_space.

Ipopt::MultiVectorMatrix::~MultiVectorMatrix | ( |  | ) | `[inline]`

Destructor.

Definition at line 225 of file IpMultiVectorMatrix.hpp.

Ipopt::MultiVectorMatrix::MultiVectorMatrix | ( |  | ) | `[private]`

Default Constructor.

Ipopt::MultiVectorMatrix::MultiVectorMatrix | ( | const MultiVectorMatrix & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

SmartPtr< MultiVectorMatrix > Ipopt::MultiVectorMatrix::MakeNewMultiVectorMatrix | ( |  | ) | const`[inline]`

Create a new MultiVectorMatrix from same MatrixSpace.

Definition at line 229 of file IpMultiVectorMatrix.hpp.

References Ipopt::MultiVectorMatrixSpace::MakeNewMultiVectorMatrix(), and owner_space_.

void Ipopt::MultiVectorMatrix::SetVector | ( | Index | i,
|  | const Vector & | vec |
| ) |  |  |

Set a particular Vector at a given column position, replacing another vector if there has been one.

Depending on whether the Vector is const or not, it is stored in the const or non-const internal column.

void Ipopt::MultiVectorMatrix::SetVectorNonConst | ( | Index | i,
|  | Vector & | vec |
| ) |  |  |

Set a particular Vector at a given column position, replacing another vector if there has been one.

Depending on whether the Vector is const or not, it is stored in the const or non-const internal column.

SmartPtr<const Vector> Ipopt::MultiVectorMatrix::GetVector | ( | Index | i | ) | const`[inline]`

Get a Vector in a particular column as a const Vector.

Definition at line 56 of file IpMultiVectorMatrix.hpp.

References ConstVec().

SmartPtr<Vector> Ipopt::MultiVectorMatrix::GetVectorNonConst | ( | Index | i | ) | `[inline]`

Get a Vector in a particular column as a non-const Vector.

This is fail if the column has currently only a non-const Vector stored.

Definition at line 64 of file IpMultiVectorMatrix.hpp.

References Ipopt::TaggedObject::ObjectChanged(), and Vec().

void Ipopt::MultiVectorMatrix::ScaleRows | ( | const Vector & | scal_vec | ) |

Method for scaling the rows of the matrix, using the ElementWiseMultiply method for each column vector.

void Ipopt::MultiVectorMatrix::ScaleColumns | ( | const Vector & | scal_vec | ) |

Method for scaling the columns of the matrix, using the Scal method for each column vector.

void Ipopt::MultiVectorMatrix::AddOneMultiVectorMatrix | ( | Number | a,
|  | const MultiVectorMatrix & | mv1,
|  | Number | c |
| ) |  |  |

Adding another MultiVectorMatrix, using the AddOneVector methods for the individual column vectors.

void Ipopt::MultiVectorMatrix::AddRightMultMatrix | ( | Number | a,
|  | const MultiVectorMatrix & | U,
|  | const Matrix & | C,
|  | Number | b |
| ) |  |  |

Multiplying a Matrix C (for now assumed to be a DenseGenMatrix) from the right to a MultiVectorMatrix U and adding the result to this MultiVectorMatrix V.

V = a * U * C + b * V.

void Ipopt::MultiVectorMatrix::FillWithNewVectors | ( |  | ) |

Method for initializing all Vectors with new (uninitialized) Vectors.

void Ipopt::MultiVectorMatrix::LRMultVector | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const

Method for adding the low-rank update matrix corresponding to this matrix to a vector.

If V is this MultiVectorMatrix, the operation is y = beta*y + alpha*V*V^T*x.

SmartPtr< const VectorSpace > Ipopt::MultiVectorMatrix::ColVectorSpace | ( |  | ) | const`[inline]`

Vector space for the columns.

Definition at line 235 of file IpMultiVectorMatrix.hpp.

References Ipopt::MultiVectorMatrixSpace::ColVectorSpace(), and owner_space_.

SmartPtr< const MultiVectorMatrixSpace > Ipopt::MultiVectorMatrix::MultiVectorMatrixOwnerSpace | ( |  | ) | const`[inline]`

Return the MultiVectorMatrixSpace.

Definition at line 242 of file IpMultiVectorMatrix.hpp.

References owner_space_.

virtual void Ipopt::MultiVectorMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, virtual]`

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual void Ipopt::MultiVectorMatrix::TransMultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, virtual]`

Matrix(transpose) vector multiply.

Computes y = alpha * Matrix^T * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::MultiVectorMatrix::HasValidNumbersImpl | ( |  | ) | const`[protected, virtual]`

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::MultiVectorMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init |
| ) |  |  | const`[protected, virtual]`

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::MultiVectorMatrix::ComputeColAMaxImpl | ( | Vector & | cols_norms,
|  | bool | init |
| ) |  |  | const`[protected, virtual]`

Compute the max-norm of the columns in the matrix.

The result is stored in cols_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::MultiVectorMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix |
| ) |  |  | const`[protected, virtual]`

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::MultiVectorMatrix::operator= | ( | const MultiVectorMatrix & |  | ) | `[private]`

Overloaded Equals Operator.

const Vector* Ipopt::MultiVectorMatrix::ConstVec | ( | Index | i | ) | const`[inline, private]`

Method for accessing the internal Vectors internally.

Definition at line 161 of file IpMultiVectorMatrix.hpp.

References const_vecs_, DBG_ASSERT, Ipopt::GetRawPtr(), Ipopt::IsValid(), Ipopt::Matrix::NCols(), and non_const_vecs_.

Referenced by GetVector().

Vector* Ipopt::MultiVectorMatrix::Vec | ( | Index | i | ) | `[inline, private]`

Method for accessing the internal Vectors internally.

Definition at line 173 of file IpMultiVectorMatrix.hpp.

References DBG_ASSERT, Ipopt::GetRawPtr(), Ipopt::IsValid(), Ipopt::Matrix::NCols(), and non_const_vecs_.

Referenced by GetVectorNonConst().

## Member Data Documentation

const MultiVectorMatrixSpace* Ipopt::MultiVectorMatrix::owner_space_`[private]`

Reimplemented from Ipopt::Matrix.

Definition at line 151 of file IpMultiVectorMatrix.hpp.

Referenced by ColVectorSpace(), MakeNewMultiVectorMatrix(), and MultiVectorMatrixOwnerSpace().

std::vector<SmartPtr<const Vector> > Ipopt::MultiVectorMatrix::const_vecs_`[private]`

space for storing the const Vector's

Definition at line 154 of file IpMultiVectorMatrix.hpp.

Referenced by ConstVec().

std::vector<SmartPtr<Vector> > Ipopt::MultiVectorMatrix::non_const_vecs_`[private]`

space for storing the non-const Vector's

Definition at line 157 of file IpMultiVectorMatrix.hpp.

Referenced by ConstVec(), and Vec().

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.7.1/Ipopt/src/LinAlg/IpMultiVectorMatrix.hpp